Index: src/docparser.h
===================================================================
--- src/docparser.h	(revision 637)
+++ src/docparser.h	(working copy)
@@ -33,6 +33,7 @@
 class Definition;
 class MemberGroup;
 class SectionDict;
+struct ParseRequest;
 
 //---------------------------------------------------------------------------
 
@@ -42,13 +43,10 @@
 void finializeDocParser();
 
 /*! Main entry point for the documentation parser.
- *  @param fileName  File in which the documentation block is found (or the
- *                   name of the example file in case isExample is TRUE).
- *  @param startLine Line at which the documentation block is found.
+ *  @param requests  List of Inputs To Parse, Each in the form of a ParseRequest
  *  @param context   Class or namespace to which this block belongs.
  *  @param md        Member definition to which the documentation belongs.
  *                   Can be 0.
- *  @param input     String representation of the documentation block.
  *  @param indexWords Indicates whether or not words should be put in the 
  *                   search index.
  *  @param isExample TRUE if the documentation belongs to an example.
@@ -61,9 +59,9 @@
  *  @returns         Root node of the abstract syntax tree. Ownership of the
  *                   pointer is handed over to the caller.
  */
-DocNode *validatingParseDoc(const char *fileName,int startLine,
+DocNode *validatingParseDoc(QList<ParseRequest> requests,
                             Definition *context, MemberDef *md,
-                            const char *input,bool indexWords,
+                            bool indexWords,
                             bool isExample,const char *exampleName=0,
                             bool singleLine=FALSE,bool linkFromIndex=FALSE);
 
@@ -78,6 +76,7 @@
                      MemberGroup *m,
                      const char *fileName);
 
+
 //---------------------------------------------------------------------------
 
 /*! @brief Abstract node interface with type information. */
@@ -146,6 +145,8 @@
     /*! Returns the parent of this node or 0 for the root node. */
     virtual DocNode *parent() const = 0;
 
+	virtual void setParent(DocNode *n) = 0;
+
     /*! Acceptor function for node visitors. Part of the visitor pattern. 
      *  @param v Abstract visitor.
      */
@@ -178,6 +179,8 @@
       v->visitPost(obj); 
     }
   
+ 	QList<DocNode> &children() { return m_children; }
+
   protected:
     QList<DocNode> m_children;
 };
@@ -193,6 +196,7 @@
     Kind kind() const { return Kind_Word; }
     DocNode *parent() const { return m_parent; }
     void accept(DocVisitor *v) { v->visit(this); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -216,6 +220,7 @@
     QString anchor() const     { return m_anchor; }
     QString tooltip() const    { return m_tooltip; }
     void accept(DocVisitor *v) { v->visit(this); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -238,6 +243,7 @@
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { v->visit(this); }
     bool isEmail() const       { return m_isEmail; }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -254,6 +260,7 @@
     Kind kind() const          { return Kind_LineBreak; }
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { v->visit(this); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -268,6 +275,7 @@
     Kind kind() const          { return Kind_HorRuler; }
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { v->visit(this); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -283,6 +291,7 @@
     QString anchor() const     { return m_anchor; }
     QString file() const       { return m_file; }
     void accept(DocVisitor *v) { v->visit(this); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -310,6 +319,7 @@
     DocNode *parent() const               { return m_parent; }
     void accept(DocVisitor *v)            { v->visit(this); }
     const HtmlAttribList &attribs() const { return m_attribs; }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -336,6 +346,7 @@
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { v->visit(this); }
     static SymType decodeSymbol(const QString &symName,char *letter);
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -353,6 +364,7 @@
     QString chars() const      { return m_chars; }
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { v->visit(this); }
+	void setParent(DocNode*n) { m_parent = n; };
   private:
     DocNode *m_parent;
     QString  m_chars;
@@ -375,6 +387,7 @@
     bool isExample() const      { return m_isExample; }
     QString exampleFile() const { return m_exampleFile; }
     QString relPath() const     { return m_relPath; }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -413,6 +426,7 @@
     QString exampleFile() const { return m_exampleFile; }
     void accept(DocVisitor *v)  { v->visit(this); }
     void parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -448,6 +462,7 @@
     bool isExample() const      { return m_isExample; }
     QString exampleFile() const { return m_exampleFile; }
     void parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -473,6 +488,7 @@
     int id() const             { return m_id; }
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { v->visit(this); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -492,6 +508,7 @@
     DocNode *parent() const      { return m_parent; }
     void accept(DocVisitor *v)   { v->visit(this); }
     QString entry()              { return m_entry; }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -512,6 +529,7 @@
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocCopy>::accept(this,v); }
     void parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -535,6 +553,7 @@
     int depth() const          { return m_depth; }
     void accept(DocVisitor *v) { CompAccept<DocAutoList>::accept(this,v); }
     int parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -555,6 +574,9 @@
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocTitle>::accept(this,v); }
 
+	QCString internalName() const;
+	void setParent(DocNode*n) { m_parent = n; };
+
   private:
     DocNode *m_parent;
 };
@@ -574,6 +596,7 @@
     QString key() const        { return m_key; }
     void accept(DocVisitor *v) { CompAccept<DocXRefItem>::accept(this,v); }
     bool parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -602,6 +625,7 @@
     const HtmlAttribList &attribs() const { return m_attribs; }
     void accept(DocVisitor *v) { CompAccept<DocImage>::accept(this,v); }
     void parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -629,6 +653,8 @@
     DocNode *parent() const    { return m_parent; }
     QString context() const    { return m_context; }
     void accept(DocVisitor *v) { CompAccept<DocDotFile>::accept(this,v); }
+	void setParent(DocNode*n) { m_parent = n; };
+
   private:
     DocNode *m_parent;
     QString  m_name;
@@ -652,6 +678,7 @@
     QString anchor() const     { return m_anchor; }
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocLink>::accept(this,v); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -679,6 +706,7 @@
     bool refToAnchor() const     { return m_refToAnchor; }
     bool refToSection() const    { return m_refToSection; }
     void accept(DocVisitor *v)   { CompAccept<DocRef>::accept(this,v); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode * m_parent;
@@ -703,6 +731,7 @@
     QString anchor() const       { return m_anchor; }
     DocNode *parent() const      { return m_parent; }
     void accept(DocVisitor *v)   { CompAccept<DocInternalRef>::accept(this,v); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode * m_parent;
@@ -740,6 +769,7 @@
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocHRef>::accept(this,v); }
     const HtmlAttribList &attribs() const { return m_attribs; }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode * m_parent;
@@ -759,6 +789,7 @@
     DocNode *parent() const               { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocHtmlHeader>::accept(this,v); }
     int parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *     m_parent;
@@ -777,6 +808,7 @@
     const HtmlAttribList &attribs() const { return m_attribs; }
     void accept(DocVisitor *v) { CompAccept<DocHtmlDescTitle>::accept(this,v); }
     int parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *     m_parent;
@@ -794,6 +826,7 @@
     const HtmlAttribList &attribs() const { return m_attribs; }
     void accept(DocVisitor *v) { CompAccept<DocHtmlDescList>::accept(this,v); }
     int parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *     m_parent;
@@ -815,6 +848,7 @@
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocSection>::accept(this,v); }
     int parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -838,6 +872,7 @@
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocSecRefItem>::accept(this,v); }
     void parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -855,6 +890,7 @@
     Kind kind() const          { return Kind_SecRefList; }
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocSecRefList>::accept(this,v); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode  *m_parent;
@@ -869,6 +905,7 @@
     Kind kind() const          { return Kind_Internal; }
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocInternal>::accept(this,v); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode  *m_parent;
@@ -883,6 +920,7 @@
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocSimpleList>::accept(this,v); }
     int parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -902,6 +940,7 @@
     const HtmlAttribList &attribs() const { return m_attribs; }
     int parse();
     int parseXml();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *     m_parent;
@@ -916,7 +955,8 @@
     enum Type 
     {  
        Unknown, See, Return, Author, Authors, Version, Since, Date,
-       Note, Warning, Pre, Post, Invar, Remark, Attention, User, Rcs
+       Note, Warning, Pre, Post, Invar, Remark, Attention, User, Rcs,
+       Progression
     };
     DocSimpleSect(DocNode *parent,Type t);
     virtual ~DocSimpleSect();
@@ -925,11 +965,15 @@
     QCString typeString() const;
     DocNode *parent() const { return m_parent; }
     void accept(DocVisitor *v);
-    int parse(bool userTitle);
+    int parse();
     int parseRcs();
     int parseXml();
     void appendLinkWord(const QString &word);
 
+    void setParent(DocNode*n) { m_parent = n; };
+	  void setTitle(DocTitle *t) { m_title = t; };
+    const DocTitle *title() const { return m_title; }
+
   private:
     DocNode *       m_parent;
     Type            m_type;
@@ -955,6 +999,7 @@
     Type type() const          { return m_type; }
     DocNode *parent() const    { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocParamSect>::accept(this,v); }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *       m_parent;
@@ -1000,6 +1045,8 @@
     int handleHtmlHeader(const HtmlAttribList &tagHtmlAttribs,int level);
     bool injectToken(int tok,const QString &tokText);
 
+	void setParent(DocNode *n) { m_parent = n; };
+
   private:
     DocNode *m_parent;
     QString  m_sectionId;
@@ -1035,6 +1082,8 @@
     int parse(const QString &cmdName);
     int parseXml(const QString &paramName);
 
+	void setParent(DocNode*n) { m_parent = n; };
+
   private:
     DocNode *               m_parent;
     QList<DocPara>          m_paragraphs;
@@ -1063,6 +1112,7 @@
     }
     int parse();
 
+	void setParent(DocNode*n) { m_parent = n; };
   private:
     DocNode *m_parent;
     DocPara *m_paragraph;
@@ -1085,6 +1135,7 @@
       m_paragraph->accept(v);
       v->visitPost(this); 
     }
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *m_parent;
@@ -1104,6 +1155,7 @@
     void accept(DocVisitor *v) { CompAccept<DocHtmlListItem>::accept(this,v); }
     int parse();
     int parseXml();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *      m_parent;
@@ -1122,6 +1174,7 @@
     DocNode *parent() const               { return m_parent; }
     void accept(DocVisitor *v) { CompAccept<DocHtmlDescData>::accept(this,v); }
     int parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *     m_parent;
@@ -1146,6 +1199,7 @@
     const HtmlAttribList &attribs() const { return m_attribs; }
     int parse();
     int parseXml();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *      m_parent;
@@ -1166,6 +1220,7 @@
     void accept(DocVisitor *v) { CompAccept<DocHtmlCaption>::accept(this,v); }
     const HtmlAttribList &attribs() const { return m_attribs; }
     int parse();
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *     m_parent;
@@ -1186,6 +1241,7 @@
     const HtmlAttribList &attribs() const { return m_attribs; }
     int parse();
     int parseXml(bool header);
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *  m_parent;
@@ -1209,6 +1265,7 @@
     int parseXml();
     uint numCols() const;
     void accept(DocVisitor *v);
+	void setParent(DocNode*n) { m_parent = n; };
 
   private:
     DocNode *          m_parent;
@@ -1225,24 +1282,30 @@
     DocNode *parent() const { return 0; }
     void accept(DocVisitor *v) { CompAccept<DocText>::accept(this,v); }
     void parse();
+	void setParent(DocNode*) { };
 };
 
 /*! @brief Root node of documentation tree */
 class DocRoot : public CompAccept<DocRoot>, public DocNode
 {
   public:
-    DocRoot(bool indent,bool sl) : m_indent(indent), m_singleLine(sl) {}
+    DocRoot(bool indent,bool sl) : m_indent(indent), m_singleLine(sl), m_lastPar(NULL) {}
     Kind kind() const       { return Kind_Root; }
     DocNode *parent() const { return 0; }
     void accept(DocVisitor *v) { CompAccept<DocRoot>::accept(this,v); }
     void parse();
     bool indent() const { return m_indent; }
     bool singleLine() const { return m_singleLine; }
+	void setParent(DocNode*) { };
 
   private:
     bool m_indent;
     bool m_singleLine;
+
+	DocPara *m_lastPar;
 };
 
 
+QCString getSimpleSectTypeString(DocSimpleSect::Type t);
+
 #endif
Index: src/translator_nl.h
===================================================================
--- src/translator_nl.h	(revision 637)
+++ src/translator_nl.h	(working copy)
@@ -18,7 +18,7 @@
 #ifndef TRANSLATOR_NL_H
 #define TRANSLATOR_NL_H
 
-class TranslatorDutch : public Translator
+class TranslatorDutch : public TranslatorAdapter_1_5_6
 {
   public:
     QCString idLanguage()
Index: src/xmlgen.cpp
===================================================================
--- src/xmlgen.cpp	(revision 637)
+++ src/xmlgen.cpp	(working copy)
@@ -27,6 +27,7 @@
 #include "util.h"
 #include "defargs.h"
 #include "outputgen.h"
+#include "outputlist.h"
 #include "dot.h"
 #include "pagedef.h"
 #include "filename.h"
@@ -479,7 +480,12 @@
   QCString stext = text.stripWhiteSpace();
   if (stext.isEmpty()) return;
   // convert the documentation string into an abstract syntax tree
-  DocNode *root = validatingParseDoc(fileName,lineNr,scope,md,text+"\n",FALSE,FALSE);
+
+  QList<ParseRequest> l_requests;
+  ParseRequest l_text = {fileName,text+"\n",lineNr};
+  l_requests.append(&l_text);
+
+  DocNode *root = validatingParseDoc(l_requests,scope,md,FALSE,FALSE);
   // create a code generator
   XMLCodeGenerator *xmlCodeGen = new XMLCodeGenerator(t);
   // create a parse tree visitor for XML
Index: src/pagedef.cpp
===================================================================
--- src/pagedef.cpp	(revision 637)
+++ src/pagedef.cpp	(working copy)
@@ -104,8 +104,12 @@
   if (!title().isEmpty() && !name().isEmpty() &&
       (si=Doxygen::sectionDict.find(pageName))!=0)
   {
+    QList<ParseRequest> l_requests;
+    ParseRequest l_doc = {docFile(),si->title,docLine()};
+    l_requests.append(&l_doc);
+
     ol.startSection(si->label,si->title,si->type);
-    ol.parseDoc(docFile(),docLine(),this,0,si->title,TRUE,FALSE);
+    ol.parseDoc(l_requests,this,0,TRUE,FALSE);
     stringToSearchIndex(getOutputFileBase(),
                         theTranslator->trPage(TRUE,TRUE)+" "+si->title,
                         si->title);
@@ -146,12 +150,14 @@
 
 void PageDef::writePageDocumentation(OutputList &ol)
 {
+  QList<ParseRequest> l_requests;
+  ParseRequest l_doc = {docFile(),documentation(),docLine()};
+  l_requests.append(&l_doc);
+
   ol.startTextBlock();
-  ol.parseDoc(docFile(),   // fileName
-      docLine(),           // startLine
+  ol.parseDoc(l_requests,  // parse requests
       this,                // context
       0,                   // memberdef
-      documentation(),     // docStr
       TRUE,                // index words
       FALSE                // not an example
       );
Index: src/translator_adapter.h
===================================================================
--- src/translator_adapter.h	(revision 637)
+++ src/translator_adapter.h	(working copy)
@@ -41,10 +41,22 @@
 
 };
 
-class TranslatorAdapter_1_5_4 : public TranslatorAdapterBase
+class TranslatorAdapter_1_5_6 : public TranslatorAdapterBase
 {
   public:
     virtual QCString updateNeededMessage()
+    { return createUpdateNeededMessage(idLanguage(),"release 1.5.6"); }
+
+    virtual QCString trProgression()
+    {
+      return english.trProgression();
+    }
+};
+
+class TranslatorAdapter_1_5_4 : public TranslatorAdapter_1_5_6
+{
+  public:
+    virtual QCString updateNeededMessage()
     { return createUpdateNeededMessage(idLanguage(),"release 1.5.4"); }
 
     virtual QCString trMemberFunctionDocumentationFortran()
Index: src/index.cpp
===================================================================
--- src/index.cpp	(revision 637)
+++ src/index.cpp	(working copy)
@@ -834,10 +834,17 @@
         if (hasBrief)
         {
           //ol.docify(" (");
+          QList<ParseRequest> l_requests;
+          ParseRequest l_brief = { 
+            fd->briefFile(), 
+            abbreviate(fd->briefDescription(), fd->name()),
+            fd->briefLine()
+          };
+          l_requests.append(&l_brief);
+
           ol.parseDoc(
-              fd->briefFile(),fd->briefLine(),
+              l_requests,
               fd,0,
-              abbreviate(fd->briefDescription(),fd->name()),
               FALSE, // index words
               FALSE, // isExample
               0,     // example name
@@ -953,10 +960,17 @@
       if (hasBrief)
       {
         //ol.docify(" (");
+        QList<ParseRequest> l_requests;
+        ParseRequest l_brief = {
+          nd->briefFile(),
+          abbreviate(nd->briefDescription(),nd->displayName()),
+          nd->briefLine()
+        };
+        l_requests.append(&l_brief);
+
         ol.parseDoc(
-                 nd->briefFile(),nd->briefLine(),
+                 l_requests,
                  nd,0,
-                 abbreviate(nd->briefDescription(),nd->displayName()),
                  FALSE, // index words
                  FALSE, // isExample
                  0,     // example name
@@ -1061,10 +1075,17 @@
       ol.startIndexValue(hasBrief);
       if (hasBrief)
       {
+        QList<ParseRequest> l_requests;
+        ParseRequest l_brief = {
+          cd->briefFile(),
+          abbreviate(cd->briefDescription(),cd->displayName()),
+          cd->briefLine()
+        };
+        l_requests.append(&l_brief);
+
         ol.parseDoc(
-                 cd->briefFile(),cd->briefLine(),
+                 l_requests,
                  cd,0,
-                 abbreviate(cd->briefDescription(),cd->displayName()),
                  FALSE,  // indexWords
                  FALSE,  // isExample
                  0,     // example name
@@ -2340,7 +2361,12 @@
   bool oldStripCommentsState = Config_getBool("STRIP_CODE_COMMENTS");
   // temporarily disable the stripping of comments for our own code example!
   Config_getBool("STRIP_CODE_COMMENTS") = FALSE;
-  ol.parseDoc("graph_legend",1,0,0,theTranslator->trLegendDocs(),FALSE,FALSE);
+
+  QList<ParseRequest> l_requests;
+  ParseRequest l_legend = {"graph_legend",theTranslator->trLegendDocs(), 1};
+  l_requests.append(&l_legend);
+
+  ol.parseDoc(l_requests,0,0,FALSE,FALSE);
   Config_getBool("STRIP_CODE_COMMENTS") = oldStripCommentsState;
   endFile(ol);
   ol.popGeneratorState();
@@ -2859,7 +2885,16 @@
   if (!Config_getString("PROJECT_NUMBER").isEmpty())
   {
     ol.startProjectNumber();
-    ol.parseDoc(defFileName,defLine,Doxygen::mainPage,0,Config_getString("PROJECT_NUMBER"),TRUE,FALSE);
+
+    QList<ParseRequest> l_requests;
+    ParseRequest l_def = {
+        defFileName,
+        Config_getString("PROJECT_NUMBER"),
+        defLine
+    };
+    l_requests.append(&l_def);
+
+    ol.parseDoc(l_requests,Doxygen::mainPage,0,TRUE,FALSE);
     ol.endProjectNumber();
   }
   if (Config_getBool("DISABLE_INDEX") && Doxygen::mainPage==0) 
@@ -2870,8 +2905,16 @@
   if (Doxygen::mainPage)
   {
     Doxygen::insideMainPage=TRUE;
-    ol.parseDoc(defFileName,defLine,Doxygen::mainPage,0,
-                Doxygen::mainPage->documentation(),TRUE,FALSE
+	
+    QList<ParseRequest> l_requests;
+    ParseRequest l_def = {
+      defFileName,
+      Doxygen::mainPage->documentation(),
+      defLine
+    };
+    l_requests.append(&l_def);
+
+    ol.parseDoc(l_requests,Doxygen::mainPage,0,TRUE,FALSE
                 /*,Doxygen::mainPage->sectionDict*/);
 
     if (!Config_getString("GENERATE_TAGFILE").isEmpty())
@@ -2920,8 +2963,16 @@
 
   if (!Config_getString("PROJECT_NUMBER").isEmpty())
   {
+    QList<ParseRequest> l_requests;
+    ParseRequest l_def = {
+      defFileName,
+      Config_getString("PROJECT_NUMBER"),
+      defLine
+    };
+    l_requests.append(&l_def);
+
     ol.startProjectNumber(); 
-    ol.parseDoc(defFileName,defLine,Doxygen::mainPage,0,Config_getString("PROJECT_NUMBER"),FALSE,FALSE);
+    ol.parseDoc(l_requests,Doxygen::mainPage,0,FALSE,FALSE);
     ol.endProjectNumber();
   }
   ol.endIndexSection(isTitlePageStart);
@@ -3074,9 +3125,16 @@
     ol.disable(OutputGenerator::Man);
     startFile(ol,Doxygen::mainPage->name(),0,Doxygen::mainPage->title());
     ol.startTextBlock();
-    ol.parseDoc(defFileName,defLine,Doxygen::mainPage,0,
-                Doxygen::mainPage->documentation(),FALSE,FALSE
-               );
+
+    QList<ParseRequest> l_requests;
+    ParseRequest l_def = {
+      defFileName,
+      Doxygen::mainPage->documentation(),
+      defLine
+    };
+    l_requests.append(&l_def);
+
+    ol.parseDoc(l_requests,Doxygen::mainPage,0,FALSE,FALSE);
     ol.endTextBlock();
     endFile(ol);
     ol.enable(OutputGenerator::Man);
Index: src/translator_tw.h
===================================================================
--- src/translator_tw.h	(revision 637)
+++ src/translator_tw.h	(working copy)
@@ -41,7 +41,7 @@
 // Translator class (by the local maintainer) when the localized
 // translator is made up-to-date again.
 
-class TranslatorChinesetraditional : public Translator
+class TranslatorChinesetraditional : public TranslatorAdapter_1_5_6
 {
   public:
 
Index: src/groupdef.cpp
===================================================================
--- src/groupdef.cpp	(revision 637)
+++ src/groupdef.cpp	(working copy)
@@ -525,7 +525,11 @@
       // repeat brief description
       if (!briefDescription().isEmpty() && Config_getBool("REPEAT_BRIEF"))
       {
-        ol.parseDoc(briefFile(),briefLine(),this,0,briefDescription(),FALSE,FALSE);
+        QList<ParseRequest> l_requests;
+        ParseRequest l_brief = { briefFile(), briefDescription(), briefLine() };
+        l_requests.append(&l_brief);
+
+        ol.parseDoc(l_requests,this,0,FALSE,FALSE);
         ol.newParagraph();
       }
     }
@@ -533,7 +537,11 @@
     // write documentation
     if (!documentation().isEmpty())
     {
-      ol.parseDoc(docFile(),docLine(),this,0,documentation()+"\n",TRUE,FALSE);
+      QList<ParseRequest> l_requests;
+      ParseRequest l_doc = { docFile(), documentation()+"\n", docLine() };
+      l_requests.append(&l_doc);
+
+      ol.parseDoc(l_requests,this,0,TRUE,FALSE);
     }
   }
 }
@@ -586,7 +594,11 @@
   }
   else if (!briefDescription().isEmpty())
   {
-    ol.parseDoc(briefFile(),briefLine(),this,0,briefDescription(),TRUE,FALSE);
+    QList<ParseRequest> l_requests;
+    ParseRequest l_brief = { briefFile(), briefDescription(), briefLine() };
+    l_requests.append(&l_brief);
+
+    ol.parseDoc(l_requests,this,0,TRUE,FALSE);
     ol.writeString(" \n");
     ol.pushGeneratorState();
     ol.disable(OutputGenerator::Latex);
@@ -632,8 +644,12 @@
       ol.endMemberItem();
       if (!fd->briefDescription().isEmpty() && Config_getBool("BRIEF_MEMBER_DESC"))
       {
+        QList<ParseRequest> l_requests;
+        ParseRequest l_brief = { briefFile(), fd->briefDescription(), briefLine() };
+        l_requests.append(&l_brief);
+
         ol.startMemberDescription();
-        ol.parseDoc(briefFile(),briefLine(),fd,0,fd->briefDescription(),FALSE,FALSE);
+        ol.parseDoc(l_requests,fd,0,FALSE,FALSE);
         ol.endMemberDescription();
         ol.newParagraph();
       }
@@ -667,8 +683,12 @@
       ol.endMemberItem();
       if (!gd->briefDescription().isEmpty() && Config_getBool("BRIEF_MEMBER_DESC"))
       {
+        QList<ParseRequest> l_requests;
+        ParseRequest l_brief = { briefFile(), gd->briefDescription(), briefLine() };
+        l_requests.append(&l_brief);
+
         ol.startMemberDescription();
-        ol.parseDoc(briefFile(),briefLine(),gd,0,gd->briefDescription(),FALSE,FALSE);
+        ol.parseDoc(l_requests,gd,0,FALSE,FALSE);
         ol.endMemberDescription();
         ol.newParagraph();
       }
@@ -698,8 +718,12 @@
       }
       if (!dd->briefDescription().isEmpty() && Config_getBool("BRIEF_MEMBER_DESC"))
       {
+        QList<ParseRequest> l_requests;
+        ParseRequest l_brief = { briefFile(), dd->briefDescription(), briefLine() };
+        l_requests.append(&l_brief);
+
         ol.startMemberDescription();
-        ol.parseDoc(briefFile(),briefLine(),dd,0,dd->briefDescription(),FALSE,FALSE);
+        ol.parseDoc(l_requests,dd,0,FALSE,FALSE);
         ol.endMemberDescription();
         ol.newParagraph();
       }
@@ -770,7 +794,12 @@
         ol.endSection(si->label,SectionInfo::Subsection);
       }
       ol.startTextBlock();
-      ol.parseDoc(pd->docFile(),pd->docLine(),pd,0,pd->documentation(),TRUE,FALSE);
+
+      QList<ParseRequest> l_requests;
+      ParseRequest l_doc = { pd->docFile(), pd->documentation(), pd->docLine() };
+      l_requests.append(&l_doc);
+
+      ol.parseDoc(l_requests,pd,0,TRUE,FALSE);
       ol.endTextBlock();
     }
   }
Index: src/cmdmapper.h
===================================================================
--- src/cmdmapper.h	(revision 637)
+++ src/cmdmapper.h	(working copy)
@@ -112,7 +112,8 @@
   CMD_INHERITDOC   = 78,
   CMD_TPARAM       = 79 | SIMPLESECT_BIT,
   CMD_COPYBRIEF    = 80,
-  CMD_COPYDETAILS  = 81
+  CMD_COPYDETAILS  = 81,
+  CMD_PROGRESSION  = 82 | SIMPLESECT_BIT
 };
 
 enum HtmlTagType
Index: src/translator_en.h
===================================================================
--- src/translator_en.h	(revision 637)
+++ src/translator_en.h	(working copy)
@@ -1776,6 +1776,14 @@
       return "Type Constraints";
     }
 
+//////////////////////////////////////////////////////////////////////////
+// new since 1.5.6 
+//////////////////////////////////////////////////////////////////////////
+    
+    virtual QCString trProgression()
+    {
+      return "Progression of Events";
+    }
 };
 
 #endif
Index: src/translator_it.h
===================================================================
--- src/translator_it.h	(revision 637)
+++ src/translator_it.h	(working copy)
@@ -80,7 +80,7 @@
 #ifndef TRANSLATOR_IT_H
 #define TRANSLATOR_IT_H
 
-class TranslatorItalian : public Translator
+class TranslatorItalian : public TranslatorAdapter_1_5_6
 {
   public:
 
Index: src/outputlist.cpp
===================================================================
--- src/outputlist.cpp	(revision 637)
+++ src/outputlist.cpp	(working copy)
@@ -130,14 +130,14 @@
   }
 }
 
-void OutputList::parseDoc(const char *fileName,int startLine,
+void OutputList::parseDoc(QList<ParseRequest> requests,
                   Definition *ctx,MemberDef * md,
-                  const QCString &docStr,bool indexWords,
+                  bool indexWords,
                   bool isExample,const char *exampleName,
                   bool singleLine,bool linkFromIndex)
 {
   int count=0;
-  if (docStr.isEmpty()) return;
+  if (requests.isEmpty()) return;
   
   OutputGenerator *og=outputs->first();
   while (og)
@@ -148,18 +148,7 @@
   if (count==0) return; // no output formats enabled.
 
   DocNode *root=0;
-  if (docStr.at(docStr.length()-1)=='\n')
-  {
-    root = validatingParseDoc(fileName,startLine,
-                              ctx,md,docStr,indexWords,isExample,exampleName,
-                              singleLine,linkFromIndex);
-  }
-  else
-  {
-    root = validatingParseDoc(fileName,startLine,
-                              ctx,md,docStr+"\n",indexWords,isExample,exampleName,
-                              singleLine,linkFromIndex);
-  }
+  root = validatingParseDoc(requests,ctx,md,indexWords,isExample,exampleName,singleLine,linkFromIndex);
 
   og=outputs->first();
   while (og)
